#include "getsolution.h"
#include <stdio.h>
#include <stdlib.h>

int size;
int* used;
char* letters;
int to_newline=0;
int count=0;
int gi=0;
int* sameas;
int matches;
char *dictionary[2000000];
extern char ** results;

int getSolution(char* string)
{
	int j=0;
	int len = strlen(string);
	matches=0;
	gi=0;
	count=0;
	to_newline=0;
	size=len;
	letters = (char *)malloc(len);
	used = malloc(4*len);
	sameas = (int*) malloc(len*4);
	
	while(j<len)
	{
		letters[j]=tolower(string[j]);
		j++;
	}
	j=0;
	
	while(j<len)
	{
		used[j]=0;
		j++;
	}	
	
	shrink_and_sort();
	*string = '\0';
	
	combinations(string,0);

	j=0;
	while(j<gi)
		free(dictionary[j++]);
	
	//free(string);
	free(used);
	free(letters);
	free(sameas);
	return matches;
}

int strsort(char* str, int len)
{
	int smal = 0;
	int index=0;
	while(index <(len-1))
	{
		int c ;
		char temp;
		smal=index;
		for(c=index;c<len;c++)
		{
			if(str[c]<=str[smal])
				smal = c;
		}
		temp = str[smal];
		str[smal] = str[index];
		str[index]=temp;
		index++;
	}		
}
void shrink_and_sort()
{
	char* input = (char*)malloc(35);
	char* shrunk = malloc(size);
	int x =0;
	int s_i=0;
	while(x<size)
	{
		int j;
		sameas[x]=-1;
		for(j=(x+1);j<size;j++)
		{
			if(letters[x]==letters[j])
			{
				sameas[x]=j;
				break;
			}
		}
		x++;
	}
	x=0;

		
	while(x<size)
	{
		int y=0;
		while(y<s_i)
		{
			if(shrunk[y]==letters[x])
			{
				y=-1;
				break;
			}
			y++;
		}
		if((s_i==0)||(y!=-1))
		{
			shrunk[s_i]=letters[x];
			s_i++;
		}
		x++;
	}
	shrunk[s_i]='\0';
	
	strsort(shrunk, s_i);
	x=0;
	while(x<s_i)
	{
		FILE* afile;
		char name[] = "*";
	
		name[0]=shrunk[x];
		afile = fopen(name, "r");
	
		while(EOF!=fscanf(afile,"%s",input))
		{

			dictionary[gi]=input;
			input= (char*)malloc(40);
			gi++;
		}
	
		x++;
		fclose(afile);
	}

	free(shrunk);

}


int	comp(char** a, char** b)
{
	return strcmp((*a),(*b));
}

void combinations(char* pre, int sofar)
{
	int i=0;
	int entered = 0;
	char* samedone;
	samedone = malloc(size);
	while(i<size)
	{
		samedone[i]=0;
		i++;
	}
	i=0;
	while(i<size)
	{
		if((used[i]==0)&&(!samedone[i]))
		{
			int j=i;
			entered=1;
			used[i]=1;
			pre[sofar]=letters[i];
			combinations(pre, sofar+1);
			used[i]=0;
			
			
			while(sameas[j]!=-1)
			{
				samedone[j]=1;
				j=sameas[j];
			}
			samedone[j]=1;
		}

		i++;
	}
	free(samedone);
	if(entered==0)
	{	
		count++;
		
		
		pre[sofar]='\0';
		{
			char** key = &pre;
			char* init=bsearch(key,dictionary, gi, 4,(int (*) (const void*, const void*)) comp);
			if(init!=NULL)
			{	
				matches++;
		
			}
		}
	}	
}


